package nl.iobyte.themeparkconnector.api.load.objects;

import nl.iobyte.themepark.ThemePark;
import nl.iobyte.themepark.api.database.DatabaseService;
import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.config.enums.StorageKey;
import nl.iobyte.themeparkconnector.api.load.interfaces.IDataLoader;

public class DatabaseLoader implements IDataLoader {

    public void load() {
        DatabaseService service = ThemePark.getInstance().getAPI().getDatabaseService();

        //Create MySQL Tables
        service.execute(
                "remote",
                "CREATE TABLE IF NOT EXISTS ridecounts(uuid VARCHAR(255) NOT NULL, attraction_id VARCHAR(255) NOT NULL, year SMALLINT(2), month SMALLINT(2), week SMALLINT(2), day SMALLINT(2), count SMALLINT(2), UNIQUE(uuid, attraction_id, year, day))",
                null
        );

        if(ThemeParkConnector.getInstance().getAPI().getConfigurationManager().getBoolean(StorageKey.ACTIONFOTO)) {
            service.execute(
                    "remote",
                    "CREATE TABLE IF NOT EXISTS actionfotos (id BIGINT(20) NOT NULL AUTO_INCREMENT, uuid VARCHAR(256) NOT NULL, ride VARCHAR(256) NOT NULL, base64 LONGBLOB NOT NULL, date TIMESTAMP NOT NULL DEFAULT CURRENT_TIMESTAMP(), UNIQUE(uuid, ride), PRIMARY KEY(id))",
                    null
            );
        }
    }

}
