package nl.iobyte.themeparkconnector.listeners;

import nl.iobyte.themeparkconnector.ThemeParkConnector;
import nl.iobyte.themeparkconnector.api.event.operator.OperatorConnectEvent;
import nl.iobyte.themeparkconnector.api.event.operator.OperatorDisconnectEvent;
import nl.iobyte.themeparkconnector.api.event.operator.OperatorStateEvent;
import nl.iobyte.themeparkconnector.api.network.packet.operator.OperatorStatePacket;
import org.bukkit.Bukkit;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;

public class OperatorListener implements Listener {

    @EventHandler
    public void onConnect(OperatorConnectEvent e) {
        String command = e.getOperator().getStartCommand();
        if(command == null || command.isEmpty())
            return;

        Bukkit.dispatchCommand(Bukkit.getConsoleSender(), command);
    }

    @EventHandler
    public void onState(OperatorStateEvent e) {
        //Change Packet
        ThemeParkConnector.getInstance().getAPI().getNetworkingService().send(
                e.getOperator().getClientConnection(),
                new OperatorStatePacket(
                        e.getItem().getID(),
                        e.getCurrent(),
                        e.getData()
                )
        );
    }

    @EventHandler
    public void onDisconnect(OperatorDisconnectEvent e) {
        String command = e.getOperator().getStopCommand();
        if(command == null || command.isEmpty())
            return;

        Bukkit.dispatchCommand(Bukkit.getConsoleSender(), command);
    }

}
